Description

When using the autocomplete feature to list issues by typing "##", an N+1 query occurs for loading associated trackers. Each issue's

tracker is queried individually.

The attached patch fixes the problem by eager-loading the tracker association.

Before:

  Issue Load (1.2ms)  SELECT `issues`.* FROM `issues` INNER JOIN `projects` ON `projects`.`id` = `

issues`.`project_id` WHERE `issues`.`project_id` = 1 AND (projects.status <> 9 AND projects.status

 <> 10 AND EXISTS (SELECT 1 AS one FROM enabled_modules em WHERE em.project_id = projects.id AND e

m.name='issue_tracking')) AND (issues.subject LIKE '%c%') ORDER BY `issues`.`id` DESC LIMIT 10

  ↳ app/controllers/auto_completes_controller.rb:36:in 'AutoCompletesController#issues'

  Tracker Load (0.4ms)  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` = 1 LIMIT 1

  ↳ app/controllers/auto_completes_controller.rb:77:in 'block in AutoCompletesController#format_is

sues_json'

  CACHE Tracker Load (0.0ms)  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` = 1 LIMIT 

1

  ↳ app/controllers/auto_completes_controller.rb:77:in 'block in AutoCompletesController#format_is

sues_json'

  CACHE Tracker Load (0.0ms)  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` = 1 LIMIT 

1

  ↳ app/controllers/auto_completes_controller.rb:77:in 'block in AutoCompletesController#format_is

sues_json'

  CACHE Tracker Load (0.0ms)  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` = 1 LIMIT 

1

  ↳ app/controllers/auto_completes_controller.rb:77:in 'block in AutoCompletesController#format_is

sues_json'

  Tracker Load (0.5ms)  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` = 2 LIMIT 1

  ↳ app/controllers/auto_completes_controller.rb:77:in 'block in AutoCompletesController#format_is

sues_json'

  CACHE Tracker Load (0.0ms)  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` = 1 LIMIT 

1

  ↳ app/controllers/auto_completes_controller.rb:77:in 'block in AutoCompletesController#format_is

sues_json'

 After:

  Issue Load (1.2ms)  SELECT `issues`.* FROM `issues` INNER JOIN `projects` ON `projects`.`id` = `

issues`.`project_id` WHERE `issues`.`project_id` = 1 AND (projects.status <> 9 AND projects.status

 <> 10 AND EXISTS (SELECT 1 AS one FROM enabled_modules em WHERE em.project_id = projects.id AND e

m.name='issue_tracking')) ORDER BY `issues`.`id` DESC LIMIT 10

  ↳ app/controllers/auto_completes_controller.rb:39:in 'AutoCompletesController#issues'

  Tracker Load (0.6ms)  SELECT `trackers`.* FROM `trackers` WHERE `trackers`.`id` IN (1, 2)
Patch by Go MAEDA (user:maeda).

Revision 23661 - 2025-04-17 03:22 - Go MAEDA

Merged r23660 from trunk to 6.0-stable (#42574).

Revision 23662 - 2025-04-17 03:22 - Go MAEDA

Merged r23660 from trunk to 5.1-stable (#42574).

History

#1 - 2025-04-13 09:01 - Go MAEDA

- Tracker changed from Defect to Feature

- Subject changed from N+1 query when listing issues in autocomplete to Optimize autocomplete issue listing triggered by typing "##" by eager loading

trackers

#2 - 2025-04-14 07:56 - Marius BĂLTEANU

- Target version changed from Candidate for next minor release to 5.1.8

#3 - 2025-04-16 08:50 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r23660.

#4 - 2025-04-17 03:23 - Go MAEDA

- Status changed from Resolved to Closed

Merged the change into the stable branches in r23661 and r23662.

Files

fix-N+1-in-AutoCompletesController.patch 705 Bytes 2025-04-12 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2025-04-19 2/2

https://www.redmine.org/projects/redmine/repository/svn/revisions/23660
https://www.redmine.org/projects/redmine/repository/svn/revisions/23661
https://www.redmine.org/projects/redmine/repository/svn/revisions/23662
http://www.tcpdf.org

